#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <sys/types.h>
#include <netdb.h>
#include <netinet/in.h>
#include <sys/socket.h>
#include <signal.h>
#include <string.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"
#include "scanner.h"
#include "ipc.h"
#include "main.h"
#include "sighand.h"

/************************/
/***	POPUP's		***/
/************************/
gboolean
on_window1_button_press_event          (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{
	if(event->button==3)
		if((int)event->window<134810000)
			gtk_menu_popup(GTK_MENU(menu1), NULL, NULL, NULL, NULL, event->button, event->time);		
 		else
			gtk_menu_popup(GTK_MENU(menu2), NULL, NULL, NULL, NULL, event->button, event->time); 
	return FALSE;
}


/***************/
/*** Entrys ***/
/***************/
gboolean 
on_sip_entry_key_press_event(GtkWidget *widget,
												GdkEventKey *event,
												gpointer user_data)
{
	if((guint *)event->keyval==65293)
		gtk_widget_grab_focus(GTK_ENTRY(lookup_widget(mwin, "eip_entry")));
  	return FALSE;
}


gboolean
on_eip_entry_key_press_event           (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data)
{
	if((guint *)event->keyval==65293)
		gtk_widget_grab_focus(GTK_ENTRY(lookup_widget(mwin, "port_entry")));
  	return FALSE;
}


gboolean
on_port_entry_key_press_event          (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data)
{
	if((guint *)event->keyval==65293)
		gtk_widget_grab_focus(GTK_BUTTON(lookup_widget(mwin, "ip_start_button")));
	return FALSE;
}


gboolean
on_ip_start_button_key_press_event     (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data)
{
	if((guint *)event->keyval==65293)
		on_ip_start_button_clicked(NULL,NULL);
  	return FALSE;
}


gboolean
on_host_entry_key_press_event          (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data)
{
	if((guint *)event->keyval==65293)
		gtk_widget_grab_focus(GTK_ENTRY(lookup_widget(mwin,"sp_entry")));
  	return FALSE;
}


gboolean
on_sp_entry_key_press_event            (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data)
{
	if((guint *)event->keyval==65293)
		gtk_widget_grab_focus(GTK_ENTRY(lookup_widget(mwin,"ep_entry")));
  	return FALSE;
}


gboolean
on_ep_entry_key_press_event            (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data)
{
	if((guint *)event->keyval==65293)
		gtk_widget_grab_focus(GTK_BUTTON(lookup_widget(mwin,"port_start_button")));
  	return FALSE;
}


gboolean
on_port_start_button_key_press_event   (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data)
{
	if((guint *)event->keyval==65293)
		on_port_start_button_clicked(NULL,NULL);
  return FALSE;
}


/****************************/
/*** Buttons  IPSCAN***/
/***************************/
void
on_ip_start_button_clicked             (GtkButton       *button,
                                        gpointer         user_data)
{
	char *ip_s, *ip_e, *port;

	if(isc)  return;
	
	ip_s=gtk_entry_get_text(GTK_ENTRY(lookup_widget(mwin,"sip_entry")));
	ip_e=gtk_entry_get_text(GTK_ENTRY(lookup_widget(mwin,"eip_entry"))); 
	port=gtk_entry_get_text(GTK_ENTRY(lookup_widget(mwin,"port_entry")));
	
	if( !strcmp(ip_s,"") || !strcmp(ip_e,"") || !strcmp(port,"") )  {
	    erro(5);
	    return;
	}    	
	
	isc=1;	
	ipcount=ip_count(ip_s,ip_e);
	
	pipe(ip_pipe);
	signal(SIGUSR1,sigusr1_parent);
	if(!(pid_ip_ch=fork()))  {
		signal(SIGUSR1,SIG_IGN);
		if(ip_scan(ip_s,ip_e,atoi(port),tt)!=0)  {
			kill(getppid(),SIGUSR1);
			sleep();
		}
		kill(getppid(),SIGUSR1);
		sleep();								
	}
	if(pid_ip_ch==-1)  {
	    signal(SIGUSR1,SIG_IGN);
	    erro(1);
	    close(ip_pipe[0]);
	    close(ip_pipe[1]);
	    isc=0;
	    return;
	}    	
	ip_ch_tag=gdk_input_add(ip_pipe[0], GDK_INPUT_READ,ip_rec,NULL);
}


void
on_ip_stop_button_clicked              (GtkButton       *button,
                                        gpointer         user_data)
{	
	if(!isc)  return;
	sigusr1_parent(SIGUSR1);
}


void
on_list1_clear_button_clicked          (GtkButton       *button,
                                        gpointer         user_data)
{
	int len;
	
	len=gtk_text_get_length(text1);
	gtk_text_backward_delete(text1,len);
}


/*********************************/
/*** Buttons  PORTSCAN***/
/********************************/
void
on_port_start_button_clicked           (GtkButton       *button,
                                        gpointer         user_data)
{
	char *host, *port_s, *port_e, *buf;
	struct hostent *hostptr;
	
	if(psc)  return;
	
	host=gtk_entry_get_text(GTK_ENTRY(lookup_widget(mwin,"host_entry")));
	port_s=gtk_entry_get_text(GTK_ENTRY(lookup_widget(mwin,"sp_entry")));
	port_e=gtk_entry_get_text(GTK_ENTRY(lookup_widget(mwin,"ep_entry")));
	
	if( !strcmp(host,"") || !strcmp(port_s,"") || !strcmp(port_e,"") )  {
	    erro(6);
	    return;
	}          
	
	psc=1;	
	pcount=atoi(port_e)-atoi(port_s);	


	if((hostptr=gethostbyname(host))==NULL) 
		if((hostptr=gethostbyaddr(host,sizeof(struct in_addr),AF_INET))==NULL)  {
			psc=0;
			erro(4);
			return;
		}

	
	buf=malloc(50);
	sprintf(buf,"Host %s:\n\n",host=inet_ntoa(* (struct in_addr *)hostptr->h_addr));
	gtk_text_insert(text2,NULL,NULL,NULL,buf,-1);
	free(buf);

	pipe(port_pipe);
	signal(SIGUSR2,sigusr2_parent);
	if(!(pid_p_ch=fork()))  {
		signal(SIGUSR2,SIG_IGN);
		if(port_scan(host,atoi(port_s),atoi(port_e),tt_port)!=0)  {
			kill(getppid(),SIGUSR2);
			sleep();
		}
		kill(getppid(),SIGUSR2);
		sleep();								
	}
	if(pid_p_ch==-1)  {
	    signal(SIGUSR2,SIG_IGN);
	    erro(1);
	    close(port_pipe[0]);
	    close(port_pipe[1]);
	    psc=0;
	    return;
	}    
	p_ch_tag=gdk_input_add(port_pipe[0], GDK_INPUT_READ,port_rec,NULL);
}


void
on_port_stop_button_clicked            (GtkButton       *button,
                                        gpointer         user_data)
{
	if(!psc)  return;
	sigusr2_parent(SIGUSR2);
}


void
on_list2_clear_button_clicked          (GtkButton       *button,
                                        gpointer         user_data)
{
	int len;
	
	len=gtk_text_get_length(text2);
	gtk_text_backward_delete(text2,len);

}


void
on_exit_button_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{
	gtk_exit(0);
}


/**************************/
/*** Menu selections ***/
/**************************/
void
on_connect1_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_scan1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	on_port_start_button_clicked(NULL,NULL);
}


void
on_stop1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	on_port_stop_button_clicked(NULL,NULL);
}


void
on_exit1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	gtk_exit(0);
}




void
on_timeout1_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	GtkWidget *tmo;
	tmo=create_dialog2();
	gtk_widget_show(tmo);
}


void
on_connect_activate                    (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_scan_activate                       (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	on_ip_start_button_clicked(NULL,NULL);
}


void
on_stop_activate                       (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	on_ip_stop_button_clicked(NULL,NULL);
}


void
on_clear_window1_activate              (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	on_list1_clear_button_clicked(NULL,NULL);
}


void
on_clear_window2_activate              (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	on_list2_clear_button_clicked(NULL,NULL);
}



/******************************/
/* Timeout dialog buttons */
/*****************************/

void
on_to_ok_button_clicked                (GtkButton       *button,
                                        gpointer         user_data)
{
	GtkWidget *e1, *e2;
	char *t1, *t2;

	e1=lookup_widget(gtk_widget_get_toplevel(button),"entry1");
	e2=lookup_widget(gtk_widget_get_toplevel(button),"entry2");

	if(strcmp(t1=gtk_entry_get_text(e1),""))
		tt=atoi(t1);
	if(strcmp(t2=gtk_entry_get_text(e2),""))
		tt_port=atoi(t2);
	
	gtk_widget_destroy(gtk_widget_get_toplevel(button));
}


void
on_to_cancel_button_clicked            (GtkButton       *button,
                                        gpointer         user_data)
{
	gtk_widget_destroy(gtk_widget_get_toplevel(button));
}


/********/
void
on_tit_ok_button_clicked               (GtkButton       *button,
                                        gpointer         user_data)
{
	gtk_widget_destroy(gtk_widget_get_toplevel(GTK_BUTTON(button)));
}


void
on_err_close_button_clicked            (GtkButton       *button,
                                        gpointer         user_data)
{
    gtk_widget_destroy(gtk_widget_get_toplevel(GTK_BUTTON(button)));
}


void
on_window1_destroy                     (GtkObject       *object,
                                        gpointer         user_data)
{
	gtk_exit(0);
}



/******************/
/* IO functions */
/*****************/
int ip_rec()
{
	struct chtof buf;
	char text[50];		
	sigset_t new,old;

	sigprocmask(SIG_BLOCK,(const sigset_t *)NULL,&new);
	sigaddset(&new,SIGUSR1);
	sigaddset(&new,SIGUSR2);
	sigprocmask(SIG_SETMASK,&new,&old);
	if(read(ip_pipe[0],buf.ip_addr,20+2*sizeof(int))!=(20+2*sizeof(int)))  {
		ipvalue=ipcount;
		gtk_progress_bar_update(GTK_PROGRESS(pbar1),ipvalue/ipcount);
		ipvalue=0;
		sigprocmask(SIG_SETMASK,&old,(sigset_t *)NULL);
		return 0;
	}
	sprintf(text,"Host %s\t",buf.ip_addr);	
	switch(buf.result)  {
		case 1:	strcat(text,"-=>\tport open\n");
					break;
		case -1: strcat(text,"-=>\ttimeout\n");
	
					break;
		case 0: strcat(text,"\n");
	}
	gtk_text_insert(text1,NULL,NULL,NULL,text,-1);
	gtk_progress_bar_update(GTK_PROGRESS(pbar1),ipvalue++/ipcount);

	sigprocmask(SIG_SETMASK,&old,(sigset_t *)NULL);
	return 1;
}


int port_rec()
{
	struct chtof buf;
	char text[50];		
	struct servent *service;
	sigset_t new,old;

	sigprocmask(SIG_BLOCK,(const sigset_t *)NULL,&new);
	sigaddset(&new,SIGUSR1);
	sigaddset(&new,SIGUSR2);
	sigprocmask(SIG_SETMASK,&new,&old);
	if(read(port_pipe[0],buf.ip_addr,20+2*sizeof(int))!=(20+2*sizeof(int)))  {
		pvalue=pcount;
		gtk_progress_bar_update(GTK_PROGRESS(pbar2),pvalue/pcount);
		pvalue=0;
		sigprocmask(SIG_SETMASK,&old,(sigset_t *)NULL);
		return 0;
	}
	switch(buf.result)  {
		case 1:	if((service=getservbyport(htons(buf.port),"tcp"))==NULL)
			    sprintf(text,"Port %5d is open. Service is unknown.\n",buf.port);
			else
			    sprintf(text,"Port %5d is open. Service is %s.\n",buf.port,service->s_name);      
					break;
		case -1: sprintf(text,"Port %5d  -=>  timeout.\n",buf.port);
						break;
	}
	if(buf.result)
		gtk_text_insert(text2,NULL,NULL,NULL,text,-1);
	gtk_progress_bar_update(GTK_PROGRESS(pbar2),(float)pvalue++/pcount);
	sigprocmask(SIG_SETMASK,&old,(sigset_t *)NULL);
	return 1;
}