#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <signal.h>
#include "scanner.h"
#include "scanfunc.h"
#include "ipc.h"


int port_scan(char *host, int port, int e_port, int timeout)
{
	struct chtof  buf;

	for(port; port<=e_port; port++)  {
		switch(pscan(host, port, timeout))  {
			case -1:	return -1;			/* sock error */
			case -2:	buf.result=0;		/* port close */
							break;
			case -3:	buf.result=-1; 		/* timeout */
							break;
			default:	buf.result=1;		/* port open */
		} 
		buf.port=port;
		write(port_pipe[1],buf.ip_addr,20+2*sizeof(int));
	}

	return 0;
}


int ip_scan(char *ip_sc, char *ip_ec, int port, int timeout)
{
	u_long start, end;
	struct chtof  buf;
	struct in_addr  ip_start;
		
	start = ntohl(inet_addr(ip_sc));
	end = ntohl(inet_addr(ip_ec));
 
    
    while(start<=end)  {
	ip_start.s_addr = htonl(start);
	start++;	    
	switch(pscan(inet_ntoa(ip_start),port, timeout))  {
	    case -1:	return -1;			/* sock error */
	    case -2:	buf.result=0;		/* port close */
			break;
	    case -3:	buf.result=-1; 		/* timeout */
			break;
	    default:	buf.result=1;		/* port open */
	}
	buf.port=port;
	strcpy(buf.ip_addr, inet_ntoa(ip_start));
	write(ip_pipe[1],buf.ip_addr,20+2*sizeof(int));
    }						
}


int alarm_on()
{
	struct sigaction handler;

	sigaction(SIGALRM,(struct sigaction *)NULL,&handler);
	handler.sa_handler=tmo;
	sigaction(SIGALRM,&handler,(struct sigaction *)NULL);
	handler.sa_handler=tmo;
	
	return 0;
}


int ip_count(char *ip_sc, char *ip_ec)
{
    u_long s,e;
    
    s = ntohl(inet_addr(ip_sc));
    e = ntohl(inet_addr(ip_ec));
    return (e-s);
}